#include <iostream>
#include <string>
using namespace std;

// add function prototypes here
string chooseMessage(float bodyMassIndex);
int getUserHeight();
float getUserWeight();
bool isValidInput(int height, float weight);
float calculateBMI(int heightInInches, float weightInPounds);


int main()
{
    int heightInInches(0);
    float weightInPounds(0);
    float bodyMassIndex(0);	// body mass index


    // Get user's height in Inches
    heightInInches = getUserHeight();

    // Get user's weight in Pounds
    weightInPounds = getUserWeight();

    // Check if input is valid (height and weight are > 0)
    // if not, then print message and stop program
    if (!isValidInput(heightInInches, weightInPounds))  {
	cout << "Invalid input." << endl;
	return 0;
    }

    // calculate user's BMI (body mass Index)
    bodyMassIndex = calculateBMI(heightInInches, weightInPounds);

    // Output BMI
    cout << "Your body mass index (BMI) is " << bodyMassIndex << endl;

    // print appropriate message
    cout << chooseMessage(bodyMassIndex);
    cout << endl;

    return 0;
}


/* Prompts user to enter height in inches.
   Returns height entered by user */
int getUserHeight()
{
    int height;
    cout << "Please enter your height in inches: ";
    cin >> height;
    return height;
}


/* Prompts user to enter weight in pounds.
   Returns weight entered by user */
float getUserWeight()
{
    int weight;
    cout << "Please enter your weight in pounds: ";
    cin >> weight;
    return weight;
}


/* Checks for validity of height and weight.
   Param height - person's height
   Param weight - person's weight
   Returns true if both are greater than 0. Otherwise returns false */
bool isValidInput(int height, float weight)
{
    if (height < 0 || weight < 0)
        return false;
    else return true;
}


/* Calculates the body mass index of a person.
   Param heightInInches - person's height in inches
   Param weightInPounds - person's weight in pounds
   Returns the body mass index for the height and weight */
float calculateBMI(int heightInInches, float weightInPounds)
{
    return (weightInPounds * 703) / (heightInInches * heightInInches);
}


/* Chooses appropriate message based on the body mass index value.
   Param bodyMassIndex - person's body mass index (BMI)
   Returns a message based on the BMI value */
string chooseMessage(float bodyMassIndex)
{
    string message;

    if (bodyMassIndex < 18.5)
	message = "You are underweight.";
    else if (bodyMassIndex < 25)
	message = "You are normal.";
    else if (bodyMassIndex < 30)
	message = "You are overweight.";
    else if (bodyMassIndex < 40)
	message = "You are obese.";
    else
	message = "You are extremely obese. Go see a doctor TODAY!";

    return message;
}


